local loader = require "AdvTiledLoader/Loader"
loader.path = "maps/"
local HC = require "HardonCollider"
local hero
local collider
local allSolidTiles

function findSolidTiles(map)
    local collidable_tiles = {}
	local layer = map.tl["ground"]
	for tileX=1,map.width do
        for tileY=1,map.height do
            local tile
			if layer.tileData[tileY] then
                tile = map.tiles[layer.tileData[tileY][tileX]]
            end
			if tile and tile.properties.solid then
				local ctile = collider:addRectangle((tileX-1)*16,(tileY-1)*16,16,16)
                ctile.type = "tile"
                collider:addToGroup("tiles", ctile)
                collider:setPassive(ctile)
                table.insert(collidable_tiles, ctile)
			end
		end
	end
	return collidable_tiles
end

function setupHero(x,y)
    hero = collider:addRectangle(x,y,16,16)
    hero.speed = 50
end

function handleInput(dt)
    if love.keyboard.isDown("left") then
        hero:move(-hero.speed*dt, 0)
    end
    if love.keyboard.isDown("right") then
        hero:move(hero.speed*dt, 0)
    end
    if love.keyboard.isDown("up") then
    end
end

function updateHero(dt)
    hero:move(0,dt*50)
end

function love.load()
    map = loader.load("level.tmx")
    collider = HC(100, on_collide)
    allSolidTiles = findSolidTiles(collider, map)
    setupHero(32,32)
end

function love.update(dt)
    handleInput(dt)
    updateHero(dt)
    collider:update(dt)
end

function love.draw()
    love.graphics.scale(2,2)
    map:draw()
    hero:draw("fill")
end

function on_collide(dt, shape_a, shape_b, mtv_x, mtv_y)
    collideHeroWithTile(dt, shape_a, shape_b, mtv_x, mtv_y)
end

function collideHeroWithTile(dt, shape_a, shape_b, mtv_x, mtv_y)
    local hero_shape, tileshape
    if shape_a == hero and shape_b.type == "tile" then
        hero_shape = shape_a
    elseif shape_b == her and shape_a.type == "tile" then
        hero_shape = shape_b
    else
        return
    end
    hero_shape:move(mtv_x, 0)
    hero_shape:move(0, mtv_y)

end